/***************************************************************************
 *   Copyright (C) 2004 by Sebastian Garcia                                *
 *   s_garcia@speedy.com.ar                                                *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 ***************************************************************************/
#ifndef GRP_H
#define GRP_H

#include <kmdimainfrm.h>
#include <kurl.h>

class QListBoxItem;

class GrpPlaylist;
class GrpPlaylistItem;
class PlaylistView;

/**
@author Sebastian Garcia
*/
class GrpApp : public KMdiMainFrm {

	Q_OBJECT

public:
	GrpApp(QWidget* parent, GrpPlaylist* plist, const char* name="GRP Playlist");

	GrpPlaylistItem *getActiveFile();
	
	void selectNextFile();
	void selectPreviousFile();

	~GrpApp();

public slots:

	void addFiles();
	void addFile( const KURL&, bool = false );

	void clearPlaylist();

protected slots:

	void playItem( GrpPlaylistItem* );

protected:

	bool queryClose();

private:

  GrpPlaylist& m_playList;
	PlaylistView *m_playListView;
	KMdiChildView *m_child;
};

#endif
