/***************************************************************************
 *   Copyright (C) 2004 by Sebastian Garcia                                *
 *   s_garcia@speedy.com.ar                                                *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 ***************************************************************************/

// More copies of Dub Playlist
 
#include <kmessagebox.h>
#include <kdebug.h>
#include <klocale.h>

#include <noatun/playlist.h>
#include <noatun/player.h>

#include "grp.h"

#include "grpplaylist.h"

/** Construct playlist object */
GrpPlaylist::GrpPlaylist()
	: Playlist(0, "GRP Playlist"),
	  grp(NULL) {
}

GrpPlaylist::~GrpPlaylist(){
	// destroy app
	if(grp)
		delete grp;
}

void GrpPlaylist::reset() {
  kdDebug() << "reset" << endl;
}

void GrpPlaylist::clear() {
  grp->clearPlaylist();
}

void GrpPlaylist::addFile(const KURL &p_url, bool p_play) {
	grp->addFile( p_url, p_play );
}

PlaylistItem GrpPlaylist::next() {
  grp->selectNextFile();
  updateCurrent();
  return m_currentItem;
}

PlaylistItem GrpPlaylist::current() {
  return m_currentItem;
}

PlaylistItem GrpPlaylist::previous() {
  grp->selectPreviousFile();
  updateCurrent();
  return m_currentItem;
}

PlaylistItem GrpPlaylist::getFirst() const {
  return 0;
/*  const KFileItem* first = dub->queryFirstFile();
  if (first) {
    GrpPlaylistItem* firstData = new GrpPlaylistItem(*first);
    return PlaylistItem(firstData);
  }
  else
    return 0;*/
}

PlaylistItem GrpPlaylist::getAfter(const PlaylistItem &/*item*/) const {
	kdDebug() << "getAfter" << endl;
	return 0;
}

bool GrpPlaylist::listVisible() const {
	return grp->isVisible();
}

void GrpPlaylist::init() {
	grp = new GrpApp(0, this);
}

void GrpPlaylist::showList() {
	grp->show();
	emit listShown();
}

void GrpPlaylist::hideList() {
	grp->hide();
	emit listHidden();
}


//void GrpPlaylist::remove(const PlaylistItem&) {
//  KMessageBox::information(0, "Removing files not supported yet, see configuration");
//}

//void GrpPlaylist::sort() {
//  kdDebug() << "sort" << endl;
//}

/*void GrpPlaylist::setCurrent(const KFileItem* file, bool play) {
  Q_ASSERT(file);
  currentItem = new GrpPlaylistItem(*file);
  if (play)
    emit playCurrent();
}*/

void GrpPlaylist::setCurrent(const PlaylistItem &play) {
	m_currentItem=play;
	emit playCurrent();
}

void GrpPlaylist::setCurrent( GrpPlaylistItem *p_item, bool p_play ) {
	m_currentItem = PlaylistItem( p_item );

	if ( p_play )
		emit playCurrent();
}

/** No descriptions */
void GrpPlaylist::updateCurrent() {
	GrpPlaylistItem *item;
	
	item = grp->getActiveFile();
	if ( item ) {
		m_currentItem = PlaylistItem( item );
		emit playCurrent();
	} else
		m_currentItem = NULL;

}
