/***************************************************************************
 *   Copyright (C) 2004 by Sebastian Garcia                                *
 *   s_garcia@speedy.com.ar                                                *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 ***************************************************************************/

// Ok, ok... a little copy of the Dub Playlist

#ifndef GRPPLAYLIST_H
#define GRPPLAYLIST_H

class GrpApp;

#include <kfileitem.h>
#include <kdebug.h>
#include <noatun/playlist.h>
#include <noatun/plugin.h>

#include "grpplaylistitem.h"

/**Playlist class. Implements the noatun playlist interface
  *
  */
class GrpPlaylist : public Playlist, public Plugin  {
public: 
  /** No descriptions */
  GrpPlaylist();
  ~GrpPlaylist();

  virtual void reset();

  virtual void clear();
  virtual void addFile( const KURL&, bool play=false );
  /**
  * Cycle everthing through forward
  **/
  virtual PlaylistItem next();
  /**
  * return the one that might/should be playing now
  **/
  virtual PlaylistItem current();
  /**
  * Cycle through backwards
  **/
  virtual PlaylistItem previous();
  virtual PlaylistItem getFirst() const;
  virtual PlaylistItem getAfter( const PlaylistItem &item ) const;

  virtual bool listVisible() const;
  virtual void init();
  virtual Playlist* playlist();

  virtual void setCurrent( const PlaylistItem &play );

public slots:
  virtual void showList();
  virtual void hideList();
	void setCurrent( GrpPlaylistItem*, bool = false );

  /** No descriptions */
  void updateCurrent();
//  virtual void remove(const PlaylistItem&);
//  virtual void sort();

private:
  GrpApp *grp;
  PlaylistItem m_currentItem;
};

inline Playlist* GrpPlaylist::playlist() {
//  kdDebug() << "playlist pointer " << this << endl;
  return static_cast<Playlist*>(this);
}

#endif
