/***************************************************************************
 *   Copyright (C) 2004 by Sebastian Garcia                                *
 *   s_garcia@speedy.com.ar                                                *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 ***************************************************************************/

// Guess what... another copy of Dub Playlist

#include <kurl.h>
#include <kfileitem.h>
#include <kdebug.h>
#include <kmessagebox.h>
#include <klocale.h>

#include "grpplaylistitem.h"

GrpPlaylistItem::GrpPlaylistItem(const KURL &p_url)
 : m_url(p_url) {

  PlaylistItemData::addRef();
//  PlaylistItemData::added();

	setProperty( "url", p_url.url() );

}

GrpPlaylistItem::~GrpPlaylistItem(){
//	remove();
}

QString GrpPlaylistItem::property(const QString &key, const QString &def) const {
  if (isProperty(key)) {
    return property_map.find(key).data();
  }
  else
    return def;
}

void GrpPlaylistItem::setProperty(const QString &key, const QString &val) {
  property_map[key] = val;
}

void GrpPlaylistItem::clearProperty(const QString &key) {
  property_map.remove(key);
}

QStringList GrpPlaylistItem::properties() const {
  QStringList list;
  for (Properties::const_iterator i=property_map.begin();
       i!=property_map.end(); i++) {
    list.append(i.key());
  }
  return list;
}

bool GrpPlaylistItem::isProperty(const QString &key) const {
  return (property_map.find(key) != property_map.end());
}

KURL GrpPlaylistItem::url() const {
  return m_url;
}

void GrpPlaylistItem::remove() {
	PlaylistItemData::removed();
}
