/***************************************************************************
 *   Copyright (C) 2004 by Sebastian Garcia                                *
 *   s_garcia@speedy.com.ar                                                *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 ***************************************************************************/

#ifndef GRPBPLAYLISTITEM_H
#define GRPPLAYLISTITEM_H

#include <kurl.h>

#include <noatun/playlist.h>

/**noatun playlistitem implementation
  *
  */
class GrpPlaylistItem : public PlaylistItemData  {

public: 
  GrpPlaylistItem(const KURL&);
  virtual ~GrpPlaylistItem();

  virtual QString property(const QString &, const QString & = 0) const;
  virtual void setProperty(const QString &, const QString &);
  virtual void clearProperty(const QString &);
  virtual QStringList properties() const;
  virtual bool isProperty(const QString &) const;
  virtual KURL url() const;
  const KURL &getFileItem();
  
	/** No descriptions */
  virtual void remove();

private:
  KURL m_url;
  typedef QMap<QString,QString> Properties;
  Properties property_map;

//	virtual QString file() const;

};

inline const KURL &GrpPlaylistItem::getFileItem(){
	return m_url;
}

#endif
